/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     A = 258,
     NS = 259,
     MX = 260,
     TXT = 261,
     CNAME = 262,
     AAAA = 263,
     PTR = 264,
     NXT = 265,
     KEY = 266,
     SOA = 267,
     SIG = 268,
     SRV = 269,
     CERT = 270,
     LOC = 271,
     MD = 272,
     MF = 273,
     MB = 274,
     MG = 275,
     MR = 276,
     YYNULL = 277,
     WKS = 278,
     HINFO = 279,
     MINFO = 280,
     RP = 281,
     AFSDB = 282,
     X25 = 283,
     ISDN = 284,
     RT = 285,
     NSAP = 286,
     NSAP_PTR = 287,
     PX = 288,
     GPOS = 289,
     EID = 290,
     NIMLOC = 291,
     ATMA = 292,
     NAPTR = 293,
     KX = 294,
     A6 = 295,
     DNAME = 296,
     SINK = 297,
     OPT = 298,
     APL = 299,
     UINFO = 300,
     UID = 301,
     GID = 302,
     UNSPEC = 303,
     TKEY = 304,
     TSIG = 305,
     IXFR = 306,
     AXFR = 307,
     MAILB = 308,
     MAILA = 309,
     DS = 310,
     RRSIG = 311,
     NSEC = 312,
     DNSKEY = 313,
     DIR_TTL = 314,
     DIR_ORIG = 315,
     NL = 316,
     ORIGIN = 317,
     SP = 318,
     STR = 319,
     PREV = 320,
     IN = 321,
     CH = 322,
     HS = 323,
     URR = 324,
     UCLASS = 325,
     UTYPE = 326
   };
#endif
#define A 258
#define NS 259
#define MX 260
#define TXT 261
#define CNAME 262
#define AAAA 263
#define PTR 264
#define NXT 265
#define KEY 266
#define SOA 267
#define SIG 268
#define SRV 269
#define CERT 270
#define LOC 271
#define MD 272
#define MF 273
#define MB 274
#define MG 275
#define MR 276
#define YYNULL 277
#define WKS 278
#define HINFO 279
#define MINFO 280
#define RP 281
#define AFSDB 282
#define X25 283
#define ISDN 284
#define RT 285
#define NSAP 286
#define NSAP_PTR 287
#define PX 288
#define GPOS 289
#define EID 290
#define NIMLOC 291
#define ATMA 292
#define NAPTR 293
#define KX 294
#define A6 295
#define DNAME 296
#define SINK 297
#define OPT 298
#define APL 299
#define UINFO 300
#define UID 301
#define GID 302
#define UNSPEC 303
#define TKEY 304
#define TSIG 305
#define IXFR 306
#define AXFR 307
#define MAILB 308
#define MAILA 309
#define DS 310
#define RRSIG 311
#define NSEC 312
#define DNSKEY 313
#define DIR_TTL 314
#define DIR_ORIG 315
#define NL 316
#define ORIGIN 317
#define SP 318
#define STR 319
#define PREV 320
#define IN 321
#define CH 322
#define HS 323
#define URR 324
#define UCLASS 325
#define UTYPE 326




/* Copy the first part of user declarations.  */
#line 1 "zparser.y"

/*
 * $Id: zparser.y,v 1.21 2004/01/09 13:19:14 erik Exp $
 *
 * zyparser.y -- yacc grammar for (DNS) zone files
 *
 * Copyright (c) 2001-2003, NLnet Labs. All rights reserved.
 *
 * See LICENSE for the license
 */

#include <config.h>
	
#include <stdio.h>
#include <string.h>

#include "dname.h"
#include "namedb.h"
#include "zonec.h"

/* these need to be global, otherwise they cannot be used inside yacc */
zparser_type *current_parser;
rr_type *current_rr;

int yywrap(void);

rrdata_type *temporary_rrdata = NULL;

/* this hold the nxt bits */
uint8_t nxtbits[16] = { '\0','\0','\0','\0',
	 		'\0','\0','\0','\0',
			'\0','\0','\0','\0',
			'\0','\0','\0','\0' };
/* 256 windows of 256 bits (32 bytes) */
/* still need to reset the bastard somewhere */
uint8_t nsecbits[256][32];



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 46 "zparser.y"
typedef union YYSTYPE {
	domain_type      *domain;
	const dname_type *dname;
	struct lex_data   data;
	uint32_t          ttl;
	uint16_t          class;
	uint16_t          type;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 265 "zparser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 277 "zparser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   298

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  73
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  34
/* YYNRULES -- Number of rules. */
#define YYNRULES  84
/* YYNRULES -- Number of states. */
#define YYNSTATES  235

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   326

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    72,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    11,    14,    17,    19,
      21,    24,    26,    29,    33,    37,    41,    44,    48,    50,
      52,    54,    57,    58,    61,    66,    71,    74,    77,    80,
      85,    90,    95,   100,   102,   104,   106,   109,   111,   115,
     117,   121,   123,   127,   129,   133,   135,   139,   143,   147,
     151,   155,   159,   163,   167,   171,   175,   179,   183,   187,
     191,   195,   199,   203,   207,   211,   215,   219,   223,   227,
     231,   234,   239,   254,   257,   266,   269,   274,   277,   282,
     291,   300,   309,   314,   319
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      74,     0,    -1,    -1,    74,    75,    -1,     1,    -1,    61,
      -1,    59,    78,    -1,    60,    79,    -1,    80,    -1,    63,
      -1,    76,    63,    -1,    61,    -1,    76,    61,    -1,    63,
      64,    77,    -1,    63,    86,    77,    -1,    62,    63,    83,
      -1,    65,    83,    -1,    85,    63,    83,    -1,    64,    -1,
      66,    -1,    70,    -1,    84,    92,    -1,    -1,    82,    63,
      -1,    81,    63,    82,    63,    -1,    82,    63,    81,    63,
      -1,    81,    63,    -1,    67,    63,    -1,    68,    63,    -1,
      81,    63,    67,    63,    -1,    81,    63,    68,    63,    -1,
      67,    63,    81,    63,    -1,    68,    63,    81,    63,    -1,
      86,    -1,    87,    -1,    72,    -1,    87,    72,    -1,    64,
      -1,    87,    72,    64,    -1,    64,    -1,    88,    76,    64,
      -1,    64,    -1,    89,    76,    64,    -1,    64,    -1,    90,
      76,    64,    -1,    64,    -1,    91,    76,    64,    -1,     7,
      76,    95,    -1,    24,    76,   100,    -1,    19,    76,    95,
      -1,    17,    76,    95,    -1,    18,    76,    95,    -1,    20,
      76,    95,    -1,    25,    76,    93,    -1,    21,    76,    95,
      -1,     5,    76,    98,    -1,     4,    76,    95,    -1,     9,
      76,    95,    -1,    12,    76,    94,    -1,     6,    76,    97,
      -1,     3,    76,    96,    -1,     8,    76,    99,    -1,    14,
      76,   101,    -1,    55,    76,   102,    -1,    11,    76,   103,
      -1,    58,    76,   103,    -1,    10,    76,   104,    -1,    57,
      76,   105,    -1,    13,    76,   106,    -1,    56,    76,   106,
      -1,     1,    61,    -1,    85,    76,    85,    77,    -1,    85,
      76,    85,    76,    64,    76,    64,    76,    64,    76,    64,
      76,    64,    77,    -1,    85,    77,    -1,    64,    72,    64,
      72,    64,    72,    64,    77,    -1,    88,    77,    -1,    64,
      76,    85,    77,    -1,    64,    77,    -1,    64,    76,    64,
      77,    -1,    64,    76,    64,    76,    64,    76,    85,    77,
      -1,    64,    76,    64,    76,    64,    76,    91,    77,    -1,
      64,    76,    64,    76,    64,    76,    91,    77,    -1,    85,
      76,    89,    77,    -1,    85,    76,    90,    77,    -1,    64,
      76,    64,    76,    64,    76,    64,    76,    64,    76,    64,
      76,    64,    76,    85,    76,    91,    77,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    75,    75,    76,    77,    80,    81,    82,    83,   102,
     103,   106,   107,   110,   122,   132,   138,   145,   155,   163,
     168,   175,   182,   186,   190,   191,   192,   196,   197,   198,
     199,   200,   201,   204,   205,   212,   216,   222,   226,   233,
     237,   246,   253,   260,   269,   278,   282,   301,   303,   305,
     307,   309,   311,   313,   315,   317,   319,   321,   323,   325,
     327,   330,   332,   334,   336,   338,   340,   342,   344,   346,
     348,   360,   368,   385,   392,   412,   415,   422,   428,   435,
     444,   453,   462,   470,   479
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "A", "NS", "MX", "TXT", "CNAME", "AAAA", 
  "PTR", "NXT", "KEY", "SOA", "SIG", "SRV", "CERT", "LOC", "MD", "MF", 
  "MB", "MG", "MR", "YYNULL", "WKS", "HINFO", "MINFO", "RP", "AFSDB", 
  "X25", "ISDN", "RT", "NSAP", "NSAP_PTR", "PX", "GPOS", "EID", "NIMLOC", 
  "ATMA", "NAPTR", "KX", "A6", "DNAME", "SINK", "OPT", "APL", "UINFO", 
  "UID", "GID", "UNSPEC", "TKEY", "TSIG", "IXFR", "AXFR", "MAILB", 
  "MAILA", "DS", "RRSIG", "NSEC", "DNSKEY", "DIR_TTL", "DIR_ORIG", "NL", 
  "ORIGIN", "SP", "STR", "PREV", "IN", "CH", "HS", "URR", "UCLASS", 
  "UTYPE", "'.'", "$accept", "lines", "line", "sp", "trail", "dir_ttl", 
  "dir_orig", "rr", "ttl", "in", "rrrest", "classttl", "dname", 
  "abs_dname", "rel_dname", "str_seq", "nxt_seq", "nsec_seq", "hex_seq", 
  "rtype", "rdata_minfo", "rdata_soa", "rdata_dname", "rdata_a", 
  "rdata_txt", "rdata_mx", "rdata_aaaa", "rdata_hinfo", "rdata_srv", 
  "rdata_ds", "rdata_dnskey", "rdata_nxt", "rdata_nsec", "rdata_rrsig", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    46
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    73,    74,    74,    74,    75,    75,    75,    75,    76,
      76,    77,    77,    78,    79,    80,    80,    80,    81,    82,
      82,    83,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    85,    85,    86,    86,    87,    87,    88,
      88,    89,    89,    90,    90,    91,    91,    92,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     1,     1,     2,     2,     1,     1,
       2,     1,     2,     3,     3,     3,     2,     3,     1,     1,
       1,     2,     0,     2,     4,     4,     2,     2,     2,     4,
       4,     4,     4,     1,     1,     1,     2,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     4,    14,     2,     8,     2,     4,     2,     4,     8,
       8,     8,     4,     4,    18
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     4,     0,     1,     0,     0,     5,     0,    37,    22,
      35,     3,     8,     0,    33,    34,     0,     6,     0,     7,
      22,    18,    19,     0,     0,    20,     0,     0,    16,     0,
      22,    36,     0,     0,     0,    15,    27,    28,    26,    23,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    21,    17,    38,    11,     9,     0,
      13,    14,     0,     0,     0,     0,     0,     0,    70,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    12,    10,    31,    32,    29,    30,    24,    25,
       0,    60,     0,    56,     0,    55,    39,     0,    59,    47,
       0,    61,    57,     0,    66,     0,    64,     0,    58,     0,
      68,     0,    62,    50,    51,    49,    52,    54,     0,    48,
       0,    53,     0,    63,    69,     0,    67,    65,     0,    73,
       0,     0,    75,    77,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    40,    41,     0,     0,     0,
       0,     0,     0,     0,     0,    43,     0,     0,    76,     0,
      82,     0,     0,     0,     0,    78,    71,     0,     0,    83,
       0,    42,     0,     0,     0,     0,     0,    44,     0,     0,
       0,     0,     0,     0,     0,    45,     0,     0,     0,     0,
       0,    74,     0,    81,     0,     0,    79,    80,    46,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    72,
       0,     0,     0,     0,    84
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     2,    11,    69,    70,    17,    19,    12,    26,    27,
      28,    29,   112,    14,    15,   117,   167,   176,   206,    64,
     141,   128,   113,   111,   118,   115,   121,   139,   132,   143,
     126,   124,   146,   130
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -200
static const short yypact[] =
{
       2,  -200,    11,  -200,   -57,   -40,  -200,    -3,  -200,    33,
    -200,  -200,  -200,    24,  -200,    81,   -28,  -200,   -43,  -200,
      33,  -200,  -200,    84,    94,  -200,   108,   110,  -200,    34,
      33,     1,    75,    75,    81,  -200,    32,    32,   -36,    32,
     126,   128,   128,   128,   128,   128,   128,   128,   128,   128,
     128,   128,   128,   128,   128,   128,   128,   128,   128,   128,
     128,   128,   128,   128,  -200,  -200,  -200,  -200,  -200,    76,
    -200,  -200,   130,   136,   139,   141,   143,   160,  -200,   -37,
     -44,   -14,    -7,   -44,     5,   -44,   -44,    14,   -44,    30,
      66,   -44,   -44,   -44,   -44,   -44,    79,   -44,    82,    30,
     -44,    14,  -200,  -200,  -200,  -200,  -200,  -200,  -200,  -200,
     153,  -200,    75,  -200,   128,  -200,  -200,    75,  -200,  -200,
      75,  -200,  -200,   128,  -200,   128,  -200,   128,  -200,   128,
    -200,   128,  -200,  -200,  -200,  -200,  -200,  -200,   128,  -200,
     128,  -200,   128,  -200,  -200,   128,  -200,  -200,   125,  -200,
     -44,   -39,  -200,  -200,    86,    88,   -44,    92,    96,    98,
     -44,   100,   102,   155,    75,  -200,  -200,    75,   128,   128,
     128,   128,    75,    75,   128,  -200,    75,   162,  -200,    18,
    -200,   104,   106,   112,   117,  -200,  -200,   120,    41,  -200,
     157,  -200,   128,   128,   128,   128,   128,  -200,   166,   122,
     134,   145,   -44,   122,    75,  -200,    75,   128,   128,    75,
      75,  -200,    70,  -200,   148,   150,  -200,  -200,  -200,   128,
     128,   152,   154,   128,   128,   156,   158,    75,   128,  -200,
     -44,   128,   122,    75,  -200
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -200,  -200,  -200,    65,   -32,  -200,  -200,  -200,   -27,   186,
     -12,  -200,    -2,   213,   219,  -200,  -200,  -200,  -199,  -200,
    -200,  -200,   -78,  -200,  -200,  -200,  -200,  -200,  -200,  -200,
     137,  -200,  -200,   144
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -3
static const short yytable[] =
{
      13,    71,    -2,     1,   210,   119,    16,   122,    35,    72,
      73,     3,    77,   133,   134,   135,   136,   137,    65,   103,
       8,     8,   102,    18,   103,   165,   103,   110,    10,    10,
      22,    74,    75,   233,    25,    40,    32,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,   103,
     114,    53,    54,    55,    56,    57,   103,   116,    58,    59,
      20,    -2,    -2,    -2,    -2,    66,    -2,    -2,   103,   120,
       4,     5,     6,     7,    -2,     8,     9,   103,   125,   102,
     149,   103,   191,    10,   123,   152,   127,    30,   153,    60,
      61,    62,    63,   103,   129,   140,    21,    21,   145,    22,
      23,    24,   102,    25,   103,   197,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   103,
     131,   102,   178,   103,   218,   180,    67,   102,    68,   103,
     185,   186,   103,   138,   189,   103,   142,    36,   164,   103,
     166,   103,   168,    31,   169,   103,   170,    37,   173,   103,
     171,   103,   172,   103,   174,   103,   175,   103,   192,   103,
     193,    38,   211,    39,   213,   103,   194,   216,   217,   150,
     103,   195,   151,   103,   196,   103,   205,    78,   154,   163,
     155,    68,   156,   104,   157,   229,   158,   103,   207,   105,
     209,   234,   106,   159,   107,   160,   108,   161,   103,   208,
     162,   103,   219,   103,   220,   103,   223,   103,   224,   103,
     227,   103,   228,   109,    76,   148,   190,   177,   231,   198,
     204,    33,   179,   181,   182,   183,   184,    34,   147,   187,
       0,   188,     0,   144,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   199,   200,   201,
     202,   203,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   212,   214,   215,     0,   212,     0,     0,     0,     0,
       0,     0,     0,     0,   221,   222,     0,     0,   225,   226,
       0,     0,     0,   230,     0,     0,   232,     0,   212
};

static const short yycheck[] =
{
       2,    33,     0,     1,   203,    83,    63,    85,    20,    36,
      37,     0,    39,    91,    92,    93,    94,    95,    30,    63,
      64,    64,    61,    63,    63,    64,    63,    64,    72,    72,
      66,    67,    68,   232,    70,     1,    64,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    63,
      64,    17,    18,    19,    20,    21,    63,    64,    24,    25,
      63,    59,    60,    61,    62,    64,    64,    65,    63,    64,
      59,    60,    61,    62,    72,    64,    65,    63,    64,    61,
     112,    63,    64,    72,    86,   117,    88,    63,   120,    55,
      56,    57,    58,    63,    64,    97,    64,    64,   100,    66,
      67,    68,    61,    70,    63,    64,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    63,
      64,    61,   164,    63,    64,   167,    61,    61,    63,    63,
     172,   173,    63,    64,   176,    63,    64,    63,   150,    63,
      64,    63,    64,    72,   156,    63,    64,    63,   160,    63,
      64,    63,    64,    63,    64,    63,    64,    63,    64,    63,
      64,    63,   204,    63,   206,    63,    64,   209,   210,   114,
      63,    64,   117,    63,    64,    63,    64,    61,   123,    64,
     125,    63,   127,    63,   129,   227,   131,    63,    64,    63,
     202,   233,    63,   138,    63,   140,    63,   142,    63,    64,
     145,    63,    64,    63,    64,    63,    64,    63,    64,    63,
      64,    63,    64,    63,    38,    72,    64,    72,   230,    72,
      64,    18,   167,   168,   169,   170,   171,    18,   101,   174,
      -1,   176,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   192,   193,   194,
     195,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   206,   207,   208,    -1,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   219,   220,    -1,    -1,   223,   224,
      -1,    -1,    -1,   228,    -1,    -1,   231,    -1,   233
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,    74,     0,    59,    60,    61,    62,    64,    65,
      72,    75,    80,    85,    86,    87,    63,    78,    63,    79,
      63,    64,    66,    67,    68,    70,    81,    82,    83,    84,
      63,    72,    64,    86,    87,    83,    63,    63,    63,    63,
       1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    17,    18,    19,    20,    21,    24,    25,
      55,    56,    57,    58,    92,    83,    64,    61,    63,    76,
      77,    77,    81,    81,    67,    68,    82,    81,    61,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,    76,    61,    63,    63,    63,    63,    63,    63,    63,
      64,    96,    85,    95,    64,    98,    64,    88,    97,    95,
      64,    99,    95,    85,   104,    64,   103,    85,    94,    64,
     106,    64,   101,    95,    95,    95,    95,    95,    64,   100,
      85,    93,    64,   102,   106,    85,   105,   103,    72,    77,
      76,    76,    77,    77,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    64,    85,    64,    64,    89,    64,    85,
      64,    64,    64,    85,    64,    64,    90,    72,    77,    76,
      77,    76,    76,    76,    76,    77,    77,    76,    76,    77,
      64,    64,    64,    64,    64,    64,    64,    64,    72,    76,
      76,    76,    76,    76,    64,    64,    91,    64,    64,    85,
      91,    77,    76,    77,    76,    76,    77,    77,    64,    64,
      64,    76,    76,    64,    64,    76,    76,    64,    64,    77,
      76,    85,    76,    91,    77
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 77 "zparser.y"
    { error("syntax error"); yyerrok; }
    break;

  case 8:
#line 84 "zparser.y"
    {   /* rr should be fully parsed */
        /*zprintrr(stderr, current_rr); DEBUG */
	    current_rr->zone = current_parser->current_zone;
	    current_rr->rrdata = region_alloc_init(
		    zone_region,
		    current_rr->rrdata,
		    rrdata_size(current_parser->_rc));

	    process_rr(current_parser, current_rr);

	    region_free_all(rr_region);
	    
	    current_rr->rrdata = temporary_rrdata;
	    current_parser->_rc = 0;
    }
    break;

  case 13:
#line 111 "zparser.y"
    { 
        if (yyvsp[-1].data.len > MAXDOMAINLEN ) {
            error("$TTL value is too large");
            return 1;
        } 
        /* perform TTL conversion */
        if ( ( current_parser->ttl = zparser_ttl2int(yyvsp[-1].data.str)) == -1 )
            current_parser->ttl = DEFAULT_TTL;
    }
    break;

  case 14:
#line 123 "zparser.y"
    {
        /* [xxx] does $origin not effect previous */
	/* [XXX] label length checks should be in dname functions */

	/* Copy from RR region to zone region.  */
        current_parser->origin = yyvsp[-1].domain;
    }
    break;

  case 15:
#line 133 "zparser.y"
    {
        current_rr->domain = current_parser->origin;

        current_parser->prev_dname = current_parser->origin;
    }
    break;

  case 16:
#line 139 "zparser.y"
    {
        /* a tab, use previously defined dname */
        /* [XXX] is null -> error, not checked (yet) MG */
        current_rr->domain = current_parser->prev_dname;
        
    }
    break;

  case 17:
#line 146 "zparser.y"
    {
	    /* Copy from RR region to zone region.  */
	    current_rr->domain = yyvsp[-2].domain;

	    /* set this as previous */
	    current_parser->prev_dname = current_rr->domain;
    }
    break;

  case 18:
#line 156 "zparser.y"
    {
        /* set the ttl */
        if ( (current_rr->rrdata->ttl = zparser_ttl2int(yyvsp[0].data.str) ) == -1 )
            current_rr->rrdata->ttl = DEFAULT_TTL;
    }
    break;

  case 19:
#line 164 "zparser.y"
    {
        /* set the class */
        current_rr->class =  current_parser->class;
    }
    break;

  case 20:
#line 169 "zparser.y"
    {
	    /* unknown RR seen */
	    current_rr->class = yyvsp[0].class;
    }
    break;

  case 21:
#line 176 "zparser.y"
    {
        zadd_rdata_finalize(current_parser);
    }
    break;

  case 22:
#line 182 "zparser.y"
    {
        current_rr->rrdata->ttl = current_parser->ttl;
        current_rr->class = current_parser->class;
    }
    break;

  case 23:
#line 187 "zparser.y"
    {
        current_rr->rrdata->ttl = current_parser->ttl;
    }
    break;

  case 26:
#line 193 "zparser.y"
    {   
        current_rr->class = current_parser->class;
    }
    break;

  case 27:
#line 196 "zparser.y"
    { error("CHAOS class not supported"); }
    break;

  case 28:
#line 197 "zparser.y"
    { error("HESIOD Class not supported"); }
    break;

  case 29:
#line 198 "zparser.y"
    { error("CHAOS class not supported"); }
    break;

  case 30:
#line 199 "zparser.y"
    { error("HESIOD class not supported"); }
    break;

  case 31:
#line 200 "zparser.y"
    { error("CHAOS class not supported"); }
    break;

  case 32:
#line 201 "zparser.y"
    { error("HESIOD class not supported"); }
    break;

  case 34:
#line 206 "zparser.y"
    {
		yyval.domain = domain_table_insert(current_parser->db->domains, 
        		cat_dname(rr_region, yyvsp[0].dname, domain_dname(current_parser->origin)));
    	}
    break;

  case 35:
#line 213 "zparser.y"
    {
	    yyval.domain = current_parser->db->domains->root;
    }
    break;

  case 36:
#line 217 "zparser.y"
    {
		yyval.domain = domain_table_insert(current_parser->db->domains, yyvsp[-1].dname);
    }
    break;

  case 37:
#line 223 "zparser.y"
    {
        yyval.dname = create_dname(rr_region, yyvsp[0].data.str, yyvsp[0].data.len);
    }
    break;

  case 38:
#line 227 "zparser.y"
    {  
        yyval.dname = cat_dname(rr_region, yyvsp[-2].dname,
		       create_dname(rr_region, yyvsp[0].data.str, yyvsp[0].data.len));
    }
    break;

  case 39:
#line 234 "zparser.y"
    {
        	zadd_rdata_wireformat( current_parser, zparser_conv_text(zone_region, yyvsp[0].data.str));
    	}
    break;

  case 40:
#line 238 "zparser.y"
    {
        	zadd_rdata_wireformat( current_parser, zparser_conv_text(zone_region, yyvsp[0].data.str));
    	}
    break;

  case 41:
#line 247 "zparser.y"
    {
		int t = intbyname(yyvsp[0].data.str,ztypes);
		set_bit( nxtbits, t );
		
		/* waar bij houden? */
	}
    break;

  case 42:
#line 254 "zparser.y"
    {
		int t = intbyname(yyvsp[0].data.str,ztypes);
		set_bit( nxtbits, t );
	}
    break;

  case 43:
#line 261 "zparser.y"
    {
		/* what if zero... */
		int t = intbyname(yyvsp[0].data.str,ztypes);
		if ( t != 0 ) 
			set_bitnsec( nsecbits, t );
		
		/* waar bij houden? */
	}
    break;

  case 44:
#line 270 "zparser.y"
    {
		int t = intbyname(yyvsp[0].data.str,ztypes);
		if ( t != 0 )
			set_bitnsec( nsecbits, t );
	}
    break;

  case 45:
#line 279 "zparser.y"
    {
		yyval.data = yyvsp[0].data;
	}
    break;

  case 46:
#line 283 "zparser.y"
    {
		char *hex = region_alloc(rr_region, yyvsp[-2].data.len + yyvsp[0].data.len + 1);
		memcpy(hex, yyvsp[-2].data.str, yyvsp[-2].data.len);
		memcpy(hex + yyvsp[-2].data.len, yyvsp[0].data.str, yyvsp[0].data.len);
		yyval.data.str = hex;
		yyval.data.len = yyvsp[-2].data.len + yyvsp[0].data.len;
		hex[yyval.data.len] = '\0';
	}
    break;

  case 47:
#line 302 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 48:
#line 304 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 49:
#line 306 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 50:
#line 308 "zparser.y"
    { error("MD is obsolete"); }
    break;

  case 51:
#line 310 "zparser.y"
    { error("MF is obsolete"); }
    break;

  case 52:
#line 312 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 53:
#line 314 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 54:
#line 316 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 55:
#line 318 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 56:
#line 320 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 57:
#line 322 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 58:
#line 324 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 59:
#line 326 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 60:
#line 328 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 61:
#line 331 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 62:
#line 333 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 63:
#line 335 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 64:
#line 337 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 65:
#line 339 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 66:
#line 341 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 67:
#line 343 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 68:
#line 345 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 69:
#line 347 "zparser.y"
    { current_rr->type = yyvsp[-2].type; }
    break;

  case 70:
#line 349 "zparser.y"
    {	
	    warning("Unimplemented RR seen");
    }
    break;

  case 71:
#line 361 "zparser.y"
    {
        /* convert a single dname record */
        zadd_rdata_domain(current_parser, yyvsp[-3].domain);
        zadd_rdata_domain(current_parser, yyvsp[-1].domain);
    }
    break;

  case 72:
#line 369 "zparser.y"
    {
        /* convert the soa data */
        zadd_rdata_domain( current_parser, yyvsp[-13].domain);                                     /* prim. ns */
        zadd_rdata_domain( current_parser, yyvsp[-11].domain);                                     /* email */
        zadd_rdata_wireformat( current_parser, zparser_conv_rdata_period(zone_region, yyvsp[-9].data.str) ); /* serial */
        zadd_rdata_wireformat( current_parser, zparser_conv_rdata_period(zone_region, yyvsp[-7].data.str) ); /* refresh */
        zadd_rdata_wireformat( current_parser, zparser_conv_rdata_period(zone_region, yyvsp[-5].data.str) ); /* retry */
        zadd_rdata_wireformat( current_parser, zparser_conv_rdata_period(zone_region, yyvsp[-3].data.str) ); /* expire */
        zadd_rdata_wireformat( current_parser, zparser_conv_rdata_period(zone_region, yyvsp[-1].data.str) ); /* minimum */

        /* [XXX] also store the minium in case of no TTL? */
        if ( (current_parser->minimum = zparser_ttl2int(yyvsp[-3].data.str) ) == -1 )
            current_parser->minimum = DEFAULT_TTL;
    }
    break;

  case 73:
#line 386 "zparser.y"
    {
        /* convert a single dname record */
        zadd_rdata_domain(current_parser, yyvsp[-1].domain);
    }
    break;

  case 74:
#line 393 "zparser.y"
    {
        /* setup the string suitable for parsing */
	    char *ipv4 = region_alloc(rr_region, yyvsp[-7].data.len + yyvsp[-5].data.len + yyvsp[-3].data.len + yyvsp[-1].data.len + 4);
        memcpy(ipv4, yyvsp[-7].data.str, yyvsp[-7].data.len);
        memcpy(ipv4 + yyvsp[-7].data.len , ".", 1);

        memcpy(ipv4 + yyvsp[-7].data.len + 1 , yyvsp[-5].data.str, yyvsp[-5].data.len);
        memcpy(ipv4 + yyvsp[-7].data.len + yyvsp[-5].data.len + 1, ".", 1);

        memcpy(ipv4 + yyvsp[-7].data.len + yyvsp[-5].data.len + 2 , yyvsp[-3].data.str, yyvsp[-3].data.len);
        memcpy(ipv4 + yyvsp[-7].data.len + yyvsp[-5].data.len + yyvsp[-3].data.len + 2, ".", 1);

        memcpy(ipv4 + yyvsp[-7].data.len + yyvsp[-5].data.len + yyvsp[-3].data.len + 3 , yyvsp[-1].data.str, yyvsp[-1].data.len);
        memcpy(ipv4 + yyvsp[-7].data.len + yyvsp[-5].data.len + yyvsp[-3].data.len + yyvsp[-1].data.len + 3, "\0", 1);

        zadd_rdata_wireformat(current_parser, zparser_conv_a(zone_region, ipv4));
    }
    break;

  case 75:
#line 412 "zparser.y"
    {}
    break;

  case 76:
#line 416 "zparser.y"
    {
        	zadd_rdata_wireformat( current_parser, zparser_conv_short(zone_region, yyvsp[-3].data.str) );  /* priority */
        	zadd_rdata_domain( current_parser, yyvsp[-1].domain);  /* MX host */
    	}
    break;

  case 77:
#line 423 "zparser.y"
    {
        	zadd_rdata_wireformat( current_parser, zparser_conv_a6(zone_region, yyvsp[-1].data.str) );  /* IPv6 address */
    	}
    break;

  case 78:
#line 429 "zparser.y"
    {
        	zadd_rdata_wireformat( current_parser, zparser_conv_text(zone_region, yyvsp[-3].data.str) ); /* CPU */
        	zadd_rdata_wireformat( current_parser, zparser_conv_text(zone_region, yyvsp[-1].data.str) ); /* OS*/
	}
    break;

  case 79:
#line 436 "zparser.y"
    {
		zadd_rdata_wireformat(current_parser, zparser_conv_short(zone_region, yyvsp[-7].data.str)); /* prio */
		zadd_rdata_wireformat(current_parser, zparser_conv_short(zone_region, yyvsp[-5].data.str)); /* weight */
		zadd_rdata_wireformat(current_parser, zparser_conv_short(zone_region, yyvsp[-3].data.str)); /* port */
		zadd_rdata_wireformat(current_parser, zparser_conv_domain(zone_region, yyvsp[-1].domain)); /* target name */
	}
    break;

  case 80:
#line 445 "zparser.y"
    {
		zadd_rdata_wireformat(current_parser, zparser_conv_short(zone_region, yyvsp[-7].data.str)); /* keytag */
		zadd_rdata_wireformat(current_parser, zparser_conv_byte(zone_region, yyvsp[-5].data.str)); /* alg */
		zadd_rdata_wireformat(current_parser, zparser_conv_byte(zone_region, yyvsp[-3].data.str)); /* type */
		zadd_rdata_wireformat(current_parser, zparser_conv_hex(zone_region, yyvsp[-1].data.str)); /* hash */
	}
    break;

  case 81:
#line 454 "zparser.y"
    {
		zadd_rdata_wireformat(current_parser, zparser_conv_short(zone_region, yyvsp[-7].data.str)); /* flags */
		zadd_rdata_wireformat(current_parser, zparser_conv_byte(zone_region, yyvsp[-5].data.str)); /* proto */
		zadd_rdata_wireformat(current_parser, zparser_conv_byte(zone_region, yyvsp[-3].data.str)); /* alg */
		zadd_rdata_wireformat(current_parser, zparser_conv_b64(zone_region, yyvsp[-1].data.str)); /* hash */
	}
    break;

  case 82:
#line 463 "zparser.y"
    {
		zadd_rdata_wireformat(current_parser, zparser_conv_domain(zone_region, yyvsp[-3].domain)); /* nxt name */
		zadd_rdata_wireformat(current_parser, zparser_conv_nxt(zone_region, nxtbits)); /* nxt bitlist */
		memset(nxtbits, 0 , 16);
	}
    break;

  case 83:
#line 471 "zparser.y"
    {
		zadd_rdata_wireformat(current_parser, zparser_conv_domain(zone_region, yyvsp[-3].domain)); /* nsec name */
		zadd_rdata_wireformat(current_parser, zparser_conv_nsec(zone_region, nsecbits)); /* nsec bitlist */
		memset(nsecbits, 0, sizeof(nsecbits));
	}
    break;

  case 84:
#line 480 "zparser.y"
    {
		zadd_rdata_wireformat(current_parser, zparser_conv_rrtype(zone_region, yyvsp[-17].data.str)); /* rr covered */
		zadd_rdata_wireformat(current_parser, zparser_conv_byte(zone_region, yyvsp[-15].data.str)); /* alg */
		zadd_rdata_wireformat(current_parser, zparser_conv_byte(zone_region, yyvsp[-13].data.str)); /* # labels */
		zadd_rdata_wireformat(current_parser, zparser_conv_rdata_period(zone_region, yyvsp[-11].data.str)); /* # orig TTL */
		zadd_rdata_wireformat(current_parser, zparser_conv_time(zone_region, yyvsp[-9].data.str)); /* sig exp */
		zadd_rdata_wireformat(current_parser, zparser_conv_time(zone_region, yyvsp[-7].data.str)); /* sig inc */
		zadd_rdata_wireformat(current_parser, zparser_conv_short(zone_region, yyvsp[-5].data.str)); /* key id */
		zadd_rdata_wireformat(current_parser, zparser_conv_domain(zone_region, yyvsp[-3].domain)); /* signer name */
		zadd_rdata_wireformat(current_parser, zparser_conv_b64(zone_region, yyvsp[-1].data.str)); /* sig data */
	}
    break;


    }

/* Line 999 of yacc.c.  */
#line 1902 "zparser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 493 "zparser.y"


int
yywrap(void)
{
    return 1;
}

